echo off
goto endcomment

What does this thing? It alarms on smart value changes.

It reads the smart value(s) (only realloc sector count and number of logged
errors) of the drive(s) noted in %DRIVES% in a log file. If any value is
different from the previous logged ones values it will create a log file with
the alarm date appended and send an email.
That way a slow degration (increasing reallocated sector count) can be seen
early. This script should be started regulary from the Task Manager. smartctl
requires admin rights, configure the Task on Vista/Win7/Win8 accordingly.

Update June 2012:
Since either the unix layer or windows driver(s) tends to
mix up the drives at every reboot (i.e. sda is not always the same drive) we
sort the drivelist by the serial numbers of the drives. This avoids
unnecessary false alarms. When an email could not be sent add a trigger-trick
to the log file to force retrying upon the next run.
Also some ssd specific values are catched now (OCZ Vertex 3 tested only).

Update April 2013:
Newer smartmontools, and differentiate between 64 bit and 32 bit windows.
Use WMI instead of date.exe from unix-tools.
Include date to email subject and in the logfile itself.

Written by jou@gmx.net / otahal@lw-datentechnik.de / http://joumxyzptlk.de

:endcomment

Setlocal EnableDelayedExpansion
set PROGDIR=C:\prog\smartmontools
set ARCH=bin
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" set ARCH=bin64
set LOGFILE=smart_realloc_count.
set DRIVES=/dev/sda /dev/sdb /dev/sdc /dev/sdd /dev/sde

cd /d "%PROGDIR%"

del %LOGFILE%hdtmp.*

set A=
for /f "skip=1 delims=" %%A in ('wmic os get localdatetime') do if not defined A set A=%%A
set CURRENTDATE=%A:~0,4%-%A:~4,2%-%A:~6,2%

if exist "%LOGFILE%1" del "%LOGFILE%1"
if exist "%LOGFILE%0" copy /y "%LOGFILE%0" "%LOGFILE%1"
echo "%COMPUTERNAME% SMART Status, Reallocated Sector Count" > "%LOGFILE%0"
for %%A in (%DRIVES%) do (
  "%PROGDIR%\%ARCH%\smartctl.exe" -a %%A | "%PROGDIR%\grep.exe" -i -e ATTRIBUTE_NAME -e Reallocated_Sector -e Spin_Retry -e Current_Pending_S -e Model -e Serial -e "error count" -e Reallocated_Event -e Retired_Block_Count -e SSD_Life_Left -e Life_Curve_Status > "%LOGFILE%tmp"
  : this is sick voodoo stuff ...
  for /f "delims=" %%B in ('grep.exe -i -e Serial "%LOGFILE%tmp" ^| cut.exe -d " " -f 6 ') do @ren "%LOGFILE%tmp" "%LOGFILE%hdtmp.%%B"
)
for /f "tokens=*" %%A in ('dir /b/on *.hdtmp.*') do (
  type %%A >> %LOGFILE%0"
  echo ------------------------------------------------------------------------------------------------>> %LOGFILE%0"
  del %%A
)
fc "%LOGFILE%0" "%LOGFILE%1"
if not errorlevel 1 goto end
copy "%LOGFILE%0" "%LOGFILE%%CURRENTDATE%"
"%PROGDIR%\sendemail-v1.56.exe" -f (senderemailadress) -t (recipientemailaddress) -s (smtp-mailserver) -xu (smtp-username) -xp (smtp-password) -o tls=no -u "%COMPUTERNAME% %CURRENTDATE% SMART Status, Reallocated Sector Count" < "%LOGFILE%%CURRENTDATE%"
if errorlevel 1 echo "Could not send email" >> "%LOGFILE%0
:end
